diff --git a/drupal7/sites/all/themes/mayo/layouts/core/one_col_vert/one_col_vert.inc b/drupal7/sites/all/themes/mayo/layouts/core/one_col_vert/one_col_vert.inc
new file mode 100644
index 00000000..caca580b
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/layouts/core/one_col_vert/one_col_vert.inc
@@ -0,0 +1,51 @@
+<?php
+
+/**
+ * @file
+ * Implimentation of a Page Layout Plugin for MAYO.
+ *
+ * @see three_col_grail.inc for detailed documentation.
+ */
+function one_col_vert() {
+  $page_layout['one_col_vert'] = array(
+    'title'    => t('One Column Vertical Sidebars'),
+    'method'   => 'one_col_vert',
+    'type'     => 'page_layout',
+    'device_groups' => array(
+      'tablet_portrait',
+      'smalltouch_landscape',
+     ),
+  );
+
+  return $page_layout;
+}
+
+/**
+ * CSS Builder for the one_col_vert layout.
+ * Displays sidebars vertically side by side beneath the main content column.
+ *
+ * @param $sidebar_first, an arbitary numeric value.
+ * @param $sidebar_second, an arbitary numeric value.
+ * @param $sidebar_unit, a value unit, one of px, em or %.
+ */
+function one_col_vert_layout($sidebar_first, $sidebar_second, $sidebar_unit) {
+
+  $one_sidebar    = $sidebar_first + $sidebar_second . $sidebar_unit;
+  $sidebar_first  = $sidebar_first . $sidebar_unit;
+  $sidebar_second = $sidebar_second . $sidebar_unit;
+
+  $styles = <<<EOF
+.two-sidebars #content,.one-sidebar #content,#sidebar-first,#sidebar-second {margin-left: 0; margin-right: 0}
+#sidebar-first {width: $sidebar_first}
+.one-sidebar #sidebar-first {width: 100%;}
+#sidebar-second {width: $sidebar_second}
+#sidebar-first,#sidebar-second {overflow: hidden; margin-top: 20px; float: left; clear: none}
+#sidebar-first .section {margin-right: 5px; margin-left: 0;}
+.one-sidebar #sidebar-first .section {margin-right: 0; margin-left: 0;}
+#sidebar-second .section {margin-right: 0; margin-left: 5px;}
+#top-columns .column-block-wrapper {width: 100% !important; margin-top: 1em;}
+#top-columns .column-block-wrapper .column-block {height: auto ; margin: 0 !important;}
+EOF;
+
+  return $styles;
+}
diff --git a/drupal7/sites/all/themes/mayo/layouts/core/three_col_grail/three_col_grail.inc b/drupal7/sites/all/themes/mayo/layouts/core/three_col_grail/three_col_grail.inc
new file mode 100644
index 00000000..58fc28d6
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/layouts/core/three_col_grail/three_col_grail.inc
@@ -0,0 +1,74 @@
+<?php
+
+/**
+ * @file
+ * Implimentation of a Page Layout Plugin.
+ *
+ * Usage:
+ * The naming convetion here is very important, the function name must match the
+ * method name and the array key. Do not add anything else to it. In the layout
+ * function simply append "_layout", this gets called when the user submits the
+ * theme settings form.
+ *
+ */
+function three_col_grail() {                     // - function name must be identical to the method and the array key.
+  $page_layout['three_col_grail'] = array(       // - array key.
+    'title'     => t('Three Column Holy Grail'), // - title, needed for the UI.
+    'method'    => 'three_col_grail',            // - method, this must match the function name and the key, definitly not optional!
+    'type'      => 'page_layout',                // - type, tell the system this is a page_layout, not optional!
+    'admin css' => 'three_col_grail.admin.css',  // - admin css, optional.
+    'device_groups' => array(                    // - device_groups, define which device groups this layout can work with, can be one or more of:
+      'bigscreen',                               //   'bigscreen', 'tablet_landscape', 'tablet_portrait', 'smalltouch_landscape'
+      'tablet_landscape',                        //   What you enter here will dictate the device groups it shows for in theme settings.
+     ),
+  );
+
+  return $page_layout;
+}
+
+/**
+ * CSS Builder for the three_col_grail layout.
+ * This does not have to be anything like this, but it must return a string of
+ * CSS, thats about it, and only has 3 bits of data to work with that come
+ * from the theme settings (what the user entered in the UI), of course you can
+ * just make up your own data if that works for  your layout, see the
+ * one_col_stack for such an implimentation.
+ *
+ * Remember, if you are building a sub-theme you have full control over the
+ * theme settings form via your sub-themes hook_form_system_theme_settings_alter()
+ * in theme-settings.php
+ *
+ * @param $sidebar_first, an arbitary numeric value.
+ * @param $sidebar_second, an arbitary numeric value.
+ * @param $sidebar_unit, a value unit, one of px, em or %.
+
+ */
+function three_col_grail_layout($sidebar_first, $sidebar_second, $sidebar_unit) {
+
+  // Set variables for language direction. In thoery a layout plugin could
+  // be RTL compatible.
+  $left = 'left';
+  $right = 'right';
+
+  // Set vars for your sidebars, this can be very different, and entirely
+  // depends on your layout.
+  $sidebar_second = $sidebar_second . $sidebar_unit;
+  $sidebar_first  = $sidebar_first . $sidebar_unit;
+
+  // Define margins/negative margins if required, AT is a content source
+  // ordered layout and uses a negative margin layout system.
+  $push_right = $sidebar_second;
+  $push_left  = $sidebar_first;
+  $pull_right = $sidebar_second;
+
+  $styles = <<<EOF
+.two-sidebars #content .section {margin-$left: $push_left; margin-$right: $push_right}
+.one-sidebar #content .section {margin-$left: $push_left;}
+#sidebar-first .section {margin-left: 0; margin-right: 10px;}
+#sidebar-second .section {margin-right: 0; margin-left: 10px;}
+#sidebar-first {width: $sidebar_first; margin-$left: -100%}
+#sidebar-second {width: $sidebar_second; margin-$left: -$pull_right}
+EOF;
+
+  return $styles;
+}
diff --git a/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_left/two_sidebars_left.inc b/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_left/two_sidebars_left.inc
new file mode 100644
index 00000000..27a75aea
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_left/two_sidebars_left.inc
@@ -0,0 +1,55 @@
+<?php
+
+/**
+ * @file
+ * Implimentation of a Page Layout Plugin for MAYO.
+ *
+ * @see three_col_grail.inc for detailed documentation.
+ */
+function two_sidebars_left() {
+  $page_layout['two_sidebars_left'] = array(
+    'title'    => t('Two Sidebars Left'),
+    'method'   => 'two_sidebars_left',
+    'type'     => 'page_layout',
+    'device_groups' => array(
+      'bigscreen',
+      'tablet_landscape',
+     ),
+  );
+
+  return $page_layout;
+}
+
+/**
+ * CSS Builder for the two_sidebars_left layout.
+ * Positions both sidebars to the left of the main content column.
+ *
+ * @param $sidebar_first, an arbitary numeric value.
+ * @param $sidebar_second, an arbitary numeric value.
+ * @param $sidebar_unit, a value unit, one of px, em or %.
+ */
+function two_sidebars_left_layout($sidebar_first, $sidebar_second, $sidebar_unit) {
+
+  $left = 'left';
+  $right = 'right';
+
+  $content_margin = $sidebar_second + $sidebar_first . $sidebar_unit;
+  $content_margin_one_sidebar = $sidebar_first . $sidebar_unit;
+  $sidebar_first  = $sidebar_first . $sidebar_unit;
+  $sidebar_second = $sidebar_second . $sidebar_unit;
+  $left_margin    = $sidebar_first;
+  $right_margin   = $sidebar_second;
+  $push_right     = $sidebar_first;
+
+  $styles = <<<EOF
+.two-sidebars #content .section {margin-$left: $content_margin; margin-$right: 0}
+.one-sidebar #content .section {margin-$left: $content_margin_one_sidebar; margin-$right: 0}
+#sidebar-first .section {margin-left: 0; margin-right: 10px;}
+#sidebar-second .section {margin-left: 0; margin-right: 10px;}
+#sidebar-first {width: $sidebar_first; margin-$left: -100%}
+#sidebar-second {width: $sidebar_second; margin-$left: -100%}
+.two-sidebars #sidebar-second {width: $sidebar_second; position: relative; $left: $push_right}
+EOF;
+
+  return $styles;
+}
diff --git a/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_left_stack/two_sidebars_left_stack.inc b/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_left_stack/two_sidebars_left_stack.inc
new file mode 100644
index 00000000..9e20e324
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_left_stack/two_sidebars_left_stack.inc
@@ -0,0 +1,53 @@
+<?php
+
+/**
+ * @file
+ * Implimentation of a Page Layout Plugin for MAYO.
+ *
+ * @see three_col_grail.inc for detailed documentation.
+ */
+function two_sidebars_left_stack() {
+  $page_layout['two_sidebars_left_stack'] = array(
+    'title'    => t('Two Sidebars Left Stacked'),
+    'method'   => 'two_sidebars_left_stack',
+    'type'     => 'page_layout',
+    'device_groups' => array(
+      'tablet_landscape',
+      'tablet_portrait',
+     ),
+  );
+
+  return $page_layout;
+}
+
+/**
+ * CSS Builder for the two_sidebars_left_stack layout.
+ * Both sidebars are pushed to the left, however the second sidebar wraps below
+ * the main content column and is 100% width. Sometimes known as a "column drop"
+ * layout, and conceptually similar to the two_sidebars_right_stack.
+ *
+ * @param $sidebar_first, an arbitary numeric value.
+ * @param $sidebar_second, an arbitary numeric value.
+ * @param $sidebar_unit, a value unit, one of px, em or %.
+ */
+function two_sidebars_left_stack_layout($sidebar_first, $sidebar_second, $sidebar_unit) {
+
+  $left = 'left';
+  $right = 'right';
+
+  $sidebar_first = $sidebar_first . $sidebar_unit;
+  $push_left     = $sidebar_first;
+
+  $styles = <<<EOF
+.two-sidebars #content .section {margin-$left: $push_left; margin-$right: 0}
+.one-sidebar #content .section {margin-$left: $push_left; margin-$right: 0}
+#sidebar-first {width: $sidebar_first; margin-$left: -100%}
+#sidebar-first .section { margin-left: 0; margin-right: 10px;}
+#sidebar-second .region-sidebar-second { display: table; width: 100%;border-spacing: 10px;}
+#sidebar-second {width: 100%; margin-left: 0; margin-right: 0; margin-top: 20px; clear: both; overflow: hidden; display: table-row;}
+#sidebar-second .block {display: table-cell;}
+#sidebar-second .section { margin: 0 -10px; }
+EOF;
+
+  return $styles;
+}
diff --git a/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_right/two_sidebars_right.inc b/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_right/two_sidebars_right.inc
new file mode 100644
index 00000000..88e89a7e
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_right/two_sidebars_right.inc
@@ -0,0 +1,57 @@
+<?php
+
+/**
+ * @file
+ * Implimentation of a Page Layout Plugin for MAYO.
+ *
+ * @see three_col_grail.inc for detailed documentation.
+ */
+function two_sidebars_right() {
+  $page_layout['two_sidebars_right'] = array(
+    'title'    => t('Two Sidebars Right'),
+    'method'   => 'two_sidebars_right',
+    'type'     => 'page_layout',
+    'device_groups' => array(
+      'bigscreen',
+      'tablet_landscape',
+     ),
+  );
+
+  return $page_layout;
+}
+
+/**
+ * CSS Builder for the two_sidebars_right layout.
+ * Positions both sidebars to the right of the main content column.
+ *
+ * @param $sidebar_first, an arbitary numeric value.
+ * @param $sidebar_second, an arbitary numeric value.
+ * @param $sidebar_unit, a value unit, one of px, em or %.
+ */
+function two_sidebars_right_layout($sidebar_first, $sidebar_second, $sidebar_unit) {
+
+  $left = 'left';
+  $right = 'right';
+
+  $content_margin = $sidebar_second + $sidebar_first . $sidebar_unit;
+  $content_margin_one_sidebar = $sidebar_first . $sidebar_unit;
+  $sidebar_first  = $sidebar_first . $sidebar_unit;
+  $sidebar_second = $sidebar_second . $sidebar_unit;
+  $push_left      = $sidebar_first;
+  $push_right     = $sidebar_second;
+  $left_margin    = $content_margin;
+  $right_margin   = $sidebar_second;
+
+  $styles = <<<EOF
+#double-right,#content-column,.content-column,div.sidebar {float: left; clear: none}
+.two-sidebars #content .section {margin-$right: $content_margin; margin-$left: 0}
+.one-sidebar #content .section {margin-$right: $content_margin_one_sidebar; margin-$left: 0}
+#sidebar-first .section {margin-right: 0; margin-left: 10px;}
+#sidebar-second .section {margin-right: 0; margin-left: 10px;}
+#sidebar-first {width: $sidebar_first; margin-$left: -$left_margin}
+.one-sidebar #sidebar-first {width: $sidebar_first; margin-$left: -$content_margin_one_sidebar}
+#sidebar-second {width: $sidebar_second; margin-$left: -$right_margin}
+EOF;
+
+  return $styles;
+}
diff --git a/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_right_stack/two_sidebars_right_stack.inc b/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_right_stack/two_sidebars_right_stack.inc
new file mode 100644
index 00000000..d6dc731a
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/layouts/core/two_sidebars_right_stack/two_sidebars_right_stack.inc
@@ -0,0 +1,53 @@
+<?php
+
+/**
+ * @file
+ * Implimentation of a Page Layout Plugin for MAYO.
+ *
+ * @see three_col_grail.inc for detailed documentation.
+ */
+function two_sidebars_right_stack() {
+  $page_layout['two_sidebars_right_stack'] = array(
+    'title'    => t('Two Sidebars Right'),
+    'method'   => 'two_sidebars_right_stack',
+    'type'     => 'page_layout',
+    'device_groups' => array(
+      'tablet_landscape',
+      'tablet_portrait',
+     ),
+  );
+
+  return $page_layout;
+}
+
+/**
+ * CSS Builder for the two_sidebars_right_stack layout.
+ * Both sidebars are pushed to the right, however the second sidebar wraps below
+ * the main content column and is 100% width. Sometimes known as a "column drop"
+ * layout, and conceptually similar to the two_sidebars_left_stack.
+ *
+ * @param $sidebar_first, an arbitary numeric value.
+ * @param $sidebar_second, an arbitary numeric value.
+ * @param $sidebar_unit, a value unit, one of px, em or %.
+ */
+function two_sidebars_right_stack_layout($sidebar_first, $sidebar_second, $sidebar_unit) {
+
+  $left = 'left';
+  $right = 'right';
+
+  $sidebar_first = $sidebar_first . $sidebar_unit;
+  $push_right    = $sidebar_first;
+
+  $styles = <<<EOF
+.two-sidebars #content .section {margin-$left: 0; margin-$right: $push_right}
+.one-sidebar #content .section {margin-$left: 0; margin-$right: $push_right}
+#sidebar-first {width: $sidebar_first; margin-$left: -$push_right; float: left; clear: none;}
+#sidebar-first .section { margin-left: 10px; margin-right: 0;}
+#sidebar-second .region-sidebar-second { display: table; width: 100%;border-spacing: 10px;}
+#sidebar-second {width: 100%; margin-left: 0; margin-right: 0; margin-top: 20px; clear: both; overflow: hidden; display: table-row;}
+#sidebar-second .block {display: table-cell;}
+#sidebar-second .section { margin: 0 -10px;}
+EOF;
+
+  return $styles;
+}
diff --git a/drupal7/sites/all/themes/mayo/mayo.info b/drupal7/sites/all/themes/mayo/mayo.info
index 0801ab83..c7f105f0 100644
--- a/drupal7/sites/all/themes/mayo/mayo.info
+++ b/drupal7/sites/all/themes/mayo/mayo.info
@@ -3,7 +3,6 @@ name = MAYO
 description = Simple but fully customizable and colorable fixed/liquid layout theme
 core = 7.x
 
-stylesheets[all][] = css/layout.css
 stylesheets[all][] = css/style.css
 stylesheets[all][] = css/colors.css
 
@@ -40,6 +39,8 @@ regions[footer_column_third] = Footer third column
 regions[footer_column_fourth] = Footer fourth column
 regions[footer] = Footer
 
+plugins[page_layout][layouts] = layouts/core
+
 settings[shortcut_module_link] = 0
 
 settings[base_font_size] = 87.5%
@@ -52,7 +53,8 @@ settings[base_vmargin] = 14px
 settings[page_width] = 90%
 settings[page_margin] = 10px
 settings[layout_style] = 1
-settings[round_corners] = 0
+settings[legacy_superfish_styles] = 0
+settings[round_corners] = 'rc-0'
 
 settings[header_searchbox] = 1
 settings[header_fontsizer] = 0
@@ -62,25 +64,91 @@ settings[logo_top_margin] = 15px
 settings[logo_left_margin] = 20px
 settings[sitename_top_margin] = 15px
 settings[sitename_left_margin] = 20px
-settings[searchbox_top_margin] = 20px
+settings[searchbox_top_margin] = 10px
 settings[searchbox_right_margin] = 15px
-settings[searchbox_size] = 24
+settings[searchbox_size] = 12
 settings[header_bg_file] = ''
 settings[header_bg_alignment] = 'top left'
 settings[header_watermark] = 0
 
 settings[menubar_style] = 1
+settings[menubar_background] = 0
+settings[menubar_bg_value] = '#ffffff'
 
-settings[sidebar_layout_style] = 1
-settings[sidebar_first_width] = 25%
-settings[sidebar_second_width] = 25%
+settings[bigscreen_sidebar_layout_style] = 1
+settings[bigscreen_sidebar_first_width] = 25%
+settings[bigscreen_sidebar_second_width] = 25%
 
 settings[display_breadcrumb] = 1
 settings[dark_messages] = 0
 
-; Information added by Drupal.org packaging script on 2014-02-11
-version = "7.x-1.3"
+settings[global_default_layout] = 'smalltouch-portrait'
+settings[iphone-land] = 0
+settings[iphone-port] = 0
+settings[ipad-port] = 0
+settings[ipad-landscape] = 0
+settings[standard-pc] = 1
+
+;----------// Layout Settings
+  ; Layout settings - Standard layout
+  settings[bigscreen_layout]         = 'three_col_grail'
+  settings[bigscreen_page_unit]      = '%'
+  settings[bigscreen_sidebar_unit]   = '%'
+  settings[bigscreen_max_width_unit] = 'px'
+  settings[bigscreen_page_width]     = 90
+  settings[bigscreen_sidebar_first]  = 25
+  settings[bigscreen_sidebar_second] = 25
+  settings[bigscreen_set_max_width]  = 1
+  settings[bigscreen_max_width]      = 1140
+  settings[bigscreen_media_query]    = 'only screen and (min-width:1025px)'
+
+
+  ; Layout settings - Tablet landscape
+  settings[tablet_landscape_layout]         = 'three_col_grail'
+  settings[tablet_landscape_page_unit]      = '%'
+  settings[tablet_landscape_sidebar_unit]   = '%'
+  settings[tablet_landscape_page_width]     = 90
+  settings[tablet_landscape_sidebar_first]  = 20
+  settings[tablet_landscape_sidebar_second] = 20
+  settings[tablet_landscape_media_query]    = 'only screen and (min-width:769px) and (max-width:1024px)'
+
+
+  ; Layout settings - Tablet portrait
+  settings[tablet_portrait_layout]         = 'one_col_vert'
+  settings[tablet_portrait_page_unit]      = '%'
+  settings[tablet_portrait_sidebar_unit]   = '%'
+  settings[tablet_portrait_page_width]     = 90
+  settings[tablet_portrait_sidebar_first]  = 50
+  settings[tablet_portrait_sidebar_second] = 50
+  settings[tablet_portrait_media_query]    = 'only screen and (min-width:481px) and (max-width:768px)'
+
+
+  ; Layout settings - Smalltouch landscape
+  settings[smalltouch_landscape_layout]         = 'one_col_vert'
+  settings[smalltouch_landscape_page_unit]      = '%'
+  settings[smalltouch_landscape_sidebar_unit]   = '%'
+  settings[smalltouch_landscape_page_width]     = 100
+  settings[smalltouch_landscape_sidebar_first]  = 50
+  settings[smalltouch_landscape_sidebar_second] = 50
+  settings[smalltouch_landscape_media_query]    = 'only screen and (min-width:321px) and (max-width:480px)'
+
+
+  ; Layout settings - Smalltouch portrait
+  settings[smalltouch_portrait_layout]         = 'one_col_stack'
+  settings[smalltouch_portrait_page_unit]      = '%'
+  settings[smalltouch_portrait_sidebar_unit]   = '%'
+  settings[smalltouch_portrait_page_width]     = 100
+  settings[smalltouch_portrait_sidebar_first]  = 100
+  settings[smalltouch_portrait_sidebar_second] = 100
+  settings[smalltouch_portrait_media_query]    = 'only screen and (max-width:320px)'
+
+  ; CSS
+  settings[global_default_layout]         = 'smalltouch-portrait'
+  settings[global_default_layout_toggle]  = 0
+  settings[global_files_path]             = 'public_files'
+; Information added by Drupal.org packaging script on 2014-05-07
+version = "7.x-2.0"
 core = "7.x"
 project = "mayo"
-datestamp = "1392154713"
+datestamp = "1399497228"
 
diff --git a/drupal7/sites/all/themes/mayo/template.php b/drupal7/sites/all/themes/mayo/template.php
old mode 100644
new mode 100755
index ad147811..3d4ae80f
--- a/drupal7/sites/all/themes/mayo/template.php
+++ b/drupal7/sites/all/themes/mayo/template.php
@@ -6,7 +6,16 @@
  */
 
 /**
- * Construst HTML code for the top/bottom block columns
+ * Includes for MAYO css creation form settings.
+ */
+global $theme_key, $path_to_mayo;
+$theme_key = $GLOBALS['theme_key'];
+$path_to_mayo = drupal_get_path('theme', 'mayo');
+include_once($path_to_mayo . '/inc/load.inc');       // drupal_add_css() wrappers
+include_once($path_to_mayo . '/inc/get.inc');        // get theme info, settings, css etc
+
+/**
+ * Construct HTML code for the top/bottom block columns
  */
 function mayo_build_columns($columns) {
   $styles = array();
@@ -54,66 +63,6 @@ function mayo_build_columns($columns) {
   return $out;
 }
 
-/**
- * Calculate margins of contents and sidebars based on the layout style
- */
-function mayo_get_margins($content, $sb_first, $sb_second) {
-  $sb_layout_style = theme_get_setting('sidebar_layout_style');
-
-  $c_margin_l =  $sf_margin_l =  $ss_margin_l = 5;
-  $c_margin_r =  $sf_margin_r =  $ss_margin_r = 5;
-
-  switch($sb_layout_style) {
-    case 1:
-      if ($sb_first) {
-        $sf_margin_l = 0;
-      }
-      else {
-        $c_margin_l = 0;
-      }
-      if ($sb_second) {
-        $ss_margin_r = 0;
-      }
-      else {
-        $c_margin_r = 0;
-      }
-      break;
-    case 2: // both sidebars come left
-      if ($sb_first) {
-        $sf_margin_l = 0;
-      }
-      else if ($sb_second) {
-        $ss_margin_l = 0;
-      }
-      else {
-        $c_margin_l = 0;
-      }
-      $c_margin_r = 0;
-      break;
-    case 3: // both sidebars come right
-      if ($sb_second) {
-        $ss_margin_r = 0;
-      }
-      else if ($sb_first) {
-        $sf_margin_r = 0;
-      }
-      else {
-        $c_margin_r = 0;
-      }
-      $c_margin_l = 0;
-      break;
-  }
-  $c_margin_style = 'margin-left: ' . $c_margin_l . 'px; margin-right: ' . $c_margin_r . 'px;';
-  $sf_margin_style = 'margin-left: ' . $sf_margin_l . 'px; margin-right: ' . $sf_margin_r . 'px;';
-  $ss_margin_style = 'margin-left: ' . $ss_margin_l . 'px; margin-right: ' . $ss_margin_r . 'px;';
-
-  return array(
-    'content' => $c_margin_style,
-    'sb_first' => $sf_margin_style,
-    'sb_second' => $ss_margin_style,
-  );
-}
-
 /**
  * Return a themed breadcrumb links
  *
@@ -141,7 +90,7 @@ function mayo_breadcrumb($variables) {
 
 /**
  * Custom search block form
- *  No 'submit button'
+ *  Magnifying glass icon used instead of 'submit button'.
  *  Use javascript to show/hide the 'search this site' prompt inside of the text field
  */
 function mayo_preprocess_search_block_form(&$variables) {
@@ -151,7 +100,7 @@ function mayo_preprocess_search_block_form(&$variables) {
 
   unset($variables['form']['actions']['submit']);
   unset($variables['form']['actions']['#children']);
-  $variables['form']['actions']['submit'] = array('#type' => 'image_button', '#src' => base_path() . path_to_theme() . '/images/search-submit.png');
+
   $variables['form']['search_block_form']['#value'] = $prompt;
   $variables['form']['search_block_form']['#size'] = theme_get_setting('searchbox_size');
   $variables['form']['search_block_form']['#attributes'] = array(
@@ -193,6 +142,17 @@ function mayo_preprocess_maintenance_page(&$variables) {
  * Implements hook_preprocess_html().
  */
 function mayo_preprocess_html(&$variables) {
+  global $theme_key;
+  // Adds classes to <body class="">
+  $settings_array = array(
+    'round_corners',
+    'dark_messages',
+  );
+  foreach ($settings_array as $setting) {
+    if (theme_get_setting($setting) !== 0) {
+      $variables['classes_array'][] = theme_get_setting($setting);
+    }
+  }
 
   // Add conditional stylesheet for IE
   drupal_add_css(path_to_theme() . '/css/ie8.css', array('group' => CSS_THEME, 'browsers' => array('IE' => 'IE 8', '!IE' => FALSE), 'preprocess' => FALSE));
@@ -205,37 +165,21 @@ function mayo_preprocess_html(&$variables) {
     'weight' => 10,
   );
 
-  // Add optional stylesheets
-
-  if (theme_get_setting('dark_messages')) {
-    // add dark.css if it's selected at the theme setting page.
-    drupal_add_css(drupal_get_path('theme', 'mayo') . '/css/dark.css', $options);
-  }
-
-  $round_corners = theme_get_setting('round_corners');
-  if ($round_corners == 1 || $round_corners == 3) {
-    drupal_add_css(drupal_get_path('theme', 'mayo') . '/css/round-sidebar.css', $options);
-  }
-  if ($round_corners == 2 || $round_corners == 3) {
-    drupal_add_css(drupal_get_path('theme', 'mayo') . '/css/round-node.css', $options);
-  }
-
   if (theme_get_setting('menubar_style') == 2) {
     drupal_add_css(drupal_get_path('theme', 'mayo') . '/css/black-menu.css', $options);
   }
 
+  // Add old legacy MAYO styles for Superfish.
+  if (theme_get_setting('legacy_superfish_styles') == 1) {
+    drupal_add_css(drupal_get_path('theme', 'mayo') . '/css/mayo-superfish.css', $options);
+  }
+
   $options = array(
     'type' => 'inline',
     'group' => CSS_THEME,
     'weight' => 10,
   );
 
-/*
-  $font_family = array(
-    0 => "font-family: Georgia, 'Palatino Linotype', 'Book Antiqua', 'URW Palladio L', Baskerville, serif; ",
-    1 => "font-family: Verdana, Geneva, Arial, 'Bitstream Vera Sans', 'DejaVu Sans', sans-serif; ",
-  );
-*/
   $font_family = array(
     // Added Japanese font support
     0 => "font-family: Georgia, 'Palatino Linotype', 'Book Antiqua', 'URW Palladio L', Baskerville, Meiryo, 'Hiragino Mincho Pro', 'MS PMincho', serif; ",
@@ -268,6 +212,11 @@ function mayo_preprocess_html(&$variables) {
     drupal_add_css(".sidebar h2 { font-size: 1.2em; }", $options);
     drupal_add_css("#content .node h2 { font-size: 1.4em; }", $options);
   }
+    // Get the path to the directory where our CSS files are saved
+  $theme_name = $theme_key;
+  $path = variable_get('theme_' . $theme_name . '_files_directory');
+    // Load Layout
+  mayo_load_layout_css($path, $theme_name);
 }
 
 /**
@@ -279,3 +228,19 @@ function mayo_process_html(&$variables) {
     _color_html_alter($variables);
   }
 }
+
+/**
+ * Implements hook_page_alter().
+ */
+function mayo_page_alter($page) {
+  // Add meta tag for viewport, for easier responsive theme design.
+  $viewport = array(
+    '#type' => 'html_tag',
+    '#tag' => 'meta',
+    '#attributes' => array(
+      'name' => 'viewport',
+      'content' => 'width=device-width, initial-scale=1',
+    ),
+  );
+  drupal_add_html_head($viewport, "viewport");
+}
\ No newline at end of file
diff --git a/drupal7/sites/all/themes/mayo/theme-settings.php b/drupal7/sites/all/themes/mayo/theme-settings.php
index b5532c83..f0e3f9b4 100644
--- a/drupal7/sites/all/themes/mayo/theme-settings.php
+++ b/drupal7/sites/all/themes/mayo/theme-settings.php
@@ -1,6 +1,6 @@
 <?php
-
 /**
+ * @file
  * Implements hook_form_system_theme_settings_alter().
  *
  * Custom theme settings
@@ -8,8 +8,50 @@
 function mayo_form_system_theme_settings_alter(&$form, &$form_state) {
 
   drupal_add_js(drupal_get_path('theme', 'mayo') . '/js/mayo.js');
+    // Get our plugin system functions.
+  require_once(drupal_get_path('theme', 'mayo') . '/inc/plugins.inc');
+
+  // We need some getters.
+  require_once(drupal_get_path('theme', 'mayo') . '/inc/get.inc');
+  $path_to_mayo = drupal_get_path('theme', 'mayo');
+
+  // General "alters" use a form id. Settings should not be set here. The only
+  // thing useful about this is if you need to alter the form for the running
+  // theme and *not* the theme setting.
+  // @see http://drupal.org/node/943212
+  if (isset($form_id)) {
+    return;
+  }
+
+  // Get an array of device groups with option values
+  $device_group_options = page_layouts_device_group_options('mayo');
+
+  // Unit options
+  $unit_options = array('%' => '%', 'px' => 'px', 'em' => 'em');
+
+  // Assign $options for each device group
+  foreach ($device_group_options as $device_group => $options) {
+
+    // About here we need to call a custom sort function, this is what we got for now
+    sort($options, SORT_STRING);
 
-  /*--------------- Font settings --------------*/
+    foreach ($options as $option) {
+      if ($device_group === 'bigscreen') {
+        $bigscreen_options[$option] = drupal_ucfirst(str_replace('_', ' ', $option)); // human readable option names for accessibility
+      }
+      if ($device_group === 'tablet_landscape') {
+        $tablet_landscape_options[$option] = drupal_ucfirst(str_replace('_', ' ', $option));
+      }
+      if ($device_group === 'tablet_portrait') {
+        $tablet_portrait_options[$option] = drupal_ucfirst(str_replace('_', ' ', $option));
+      }
+      if ($device_group === 'smalltouch_landscape') {
+        $smalltouch_landscape_options[$option] = drupal_ucfirst(str_replace('_', ' ', $option));
+      }
+    }
+  }
+
+  /* --------------- Font settings -------------- */
   $form['font'] = array(
     '#type' => 'fieldset',
     '#title' => t('Font settings'),
@@ -71,7 +113,7 @@ function mayo_form_system_theme_settings_alter(&$form, &$form_state) {
     '#suffix' => '</div>',
   );
 
-  /*--------------- Layout settings --------------*/
+  /* --------------- Layout settings -------------- */
   $form['layout'] = array(
     '#type' => 'fieldset',
     '#title' => t('Layout settings'),
@@ -87,15 +129,6 @@ function mayo_form_system_theme_settings_alter(&$form, &$form_state) {
     '#description' => t('Specify the base vertical (top/bottom) margin which is vertical spaces between page edge and browser screen in px.'),
     '#prefix' => '<img src="/' . drupal_get_path('theme', 'mayo') . '/images/base-layout.png" /><br />',
   );
-  $form['layout']['page_width'] = array(
-    '#type' => 'textfield',
-    '#title' => t('Page width'),
-    '#default_value' => theme_get_setting('page_width'),
-    '#size' => 12,
-    '#maxlength' => 8,
-    '#description' => t('Specify the page width including sidebars either in percent ratio (50-100%) for liquid layout, or in px (700-1600px) for fixed layout. If an invalid value is specified, the default value (90%) is used instead. You can leave this field blank to use the default value. Do not forget to add either % or px after the number.'),
-    '#element_validate' => array('mayo_page_width_validate'),
-  );
   $form['layout']['page_margin'] = array(
     '#type' => 'textfield',
     '#title' => t('Page margin'),
